#ifndef  FUNCS_DOS_FUNCS_H
#define  FUNCS_DOS_FUNCS_H

/*
**
** Function declarations for ACE Basic
**
** Note: Translated to ACE by Nils Sjoholm
**
** Date: 11-Oct-95 TO 14-Oct-95
**
*/              

#ifndef  EXEC_TYPES_H
#include <exec/types.h>
#endif

DECLARE FUNCTION BPTR _Open( STRPTR _name, LONGINT accessMode ) LIBRARY dos
DECLARE FUNCTION LONGINT _Close( BPTR file ) LIBRARY dos
DECLARE FUNCTION LONGINT _Read( BPTR file, APTR buffer, LONGINT length ) LIBRARY dos
DECLARE FUNCTION LONGINT _Write( BPTR file, APTR buffer, LONGINT length ) LIBRARY dos
DECLARE FUNCTION BPTR _Input() LIBRARY dos
DECLARE FUNCTION BPTR _Output() LIBRARY dos
DECLARE FUNCTION LONGINT Seek( BPTR file, LONGINT position, LONGINT offset ) LIBRARY dos
DECLARE FUNCTION LONGINT DeleteFile( STRPTR _name) LIBRARY dos
DECLARE FUNCTION LONGINT Rename( STRPTR oldName, STRPTR newName ) LIBRARY dos
DECLARE FUNCTION BPTR Lock( STRPTR _name, LONGINT _Type ) LIBRARY dos
DECLARE FUNCTION UnLock( BPTR lock ) LIBRARY dos
DECLARE FUNCTION BPTR DupLock( BPTR lock ) LIBRARY dos
DECLARE FUNCTION LONGINT Examine( BPTR lock, STRUCTPTR fileInfoBlock ) LIBRARY dos
DECLARE FUNCTION LONGINT ExNext( BPTR lock, STRUCTPTR fileInfoBlock ) LIBRARY dos
DECLARE FUNCTION LONGINT Info( BPTR lock, STRUCTPTR parameterBlock ) LIBRARY dos
DECLARE FUNCTION BPTR CreateDir( STRPTR _Name ) LIBRARY dos
DECLARE FUNCTION BPTR CurrentDir( BPTR lock ) LIBRARY dos
DECLARE FUNCTION LONGINT IoErr() LIBRARY dos
DECLARE FUNCTION STRUCTPTR CreateProc( STRPTR _name, LONGINT pri, BPTR segList, \
                                       LONGINT stackSize ) LIBRARY dos
DECLARE FUNCTION _Exit( LONGINT returnCode ) LIBRARY dos
DECLARE FUNCTION BPTR LoadSeg( STRPTR _Name ) LIBRARY dos
DECLARE FUNCTION UnLoadSeg( BPTR seglist ) LIBRARY dos
DECLARE FUNCTION STRUCTPTR DeviceProc( STRPTR _name ) LIBRARY dos
DECLARE FUNCTION LONGINT SetComment( STRPTR _name, STRPTR comment ) LIBRARY dos
DECLARE FUNCTION LONGINT SetProtection( STRPTR _name, LONGINT protect ) LIBRARY dos
DECLARE FUNCTION STRUCTPTR DateStamp( STRUCTPTR date ) LIBRARY dos
DECLARE FUNCTION Delay( LONGINT timeout ) LIBRARY dos
DECLARE FUNCTION LONGINT WaitForChar( BPTR file, LONGINT timeout ) LIBRARY dos
DECLARE FUNCTION BPTR ParentDir( BPTR lock ) LIBRARY dos
DECLARE FUNCTION LONGINT IsInteractive( BPTR file ) LIBRARY dos
DECLARE FUNCTION LONGINT Execute( STRPTR _string, BPTR file, BPTR file2 ) LIBRARY dos
/*--- functions in V36 OR higher (Release 2.0) ---*/
/*  DOS Object creation/deletion */
DECLARE FUNCTION APTR AllocDosObject( LONGINT _type, STRUCTPTR tags ) LIBRARY dos
DECLARE FUNCTION FreeDosObject( LONGINT _TYPE, APTR ptr ) LIBRARY dos
/*  Packet Level routines */
DECLARE FUNCTION LONGINT DoPkt( STRUCTPTR port, LONGINT action, LONGINT arg1, \
                                LONGINT arg2, LONGINT arg3, \
                                LONGINT arg4, LONGINT arg5 ) LIBRARY dos
DECLARE FUNCTION SendPkt( STRUCTPTR dp, STRUCTPTR port, \
                          STRUCTPTR replyport ) LIBRARY dos
DECLARE FUNCTION STRUCTPTR WaitPkt() LIBRARY dos
DECLARE FUNCTION ReplyPkt( STRUCTPTR dp, LONGINT res1, LONGINT res2 ) LIBRARY dos
DECLARE FUNCTION AbortPkt( STRUCTPTR port, STRUCTPTR pkt ) LIBRARY dos
/*  Record Locking */
DECLARE FUNCTION BOOL LockRecord( BPTR fh, LONGINT offset, LONGINT length, \
                                  LONGINT mode, LONGINT timeout ) LIBRARY dos
DECLARE FUNCTION BOOL LockRecords( STRUCTPTR recArray, LONGINT timeout ) LIBRARY dos
DECLARE FUNCTION BOOL UnLockRecord( BPTR fh, LONGINT offset, LONGINT length ) LIBRARY dos
DECLARE FUNCTION BOOL UnLockRecords( STRUCTPTR recArray ) LIBRARY dos
/*  Buffered File I/O */
DECLARE FUNCTION BPTR SelectInput( BPTR fh ) LIBRARY dos
DECLARE FUNCTION BPTR SelectOutput( BPTR fh ) LIBRARY dos
DECLARE FUNCTION LONGINT FGetC( BPTR fh ) LIBRARY dos
DECLARE FUNCTION LONGINT FPutC( BPTR fh, LONGINT ch ) LIBRARY dos
DECLARE FUNCTION LONGINT UnGetC( BPTR fh, LONGINT character ) LIBRARY dos
DECLARE FUNCTION LONGINT FRead( BPTR fh, APTR theBlock, LONGINT blocklen, \
                                LONGINT number ) LIBRARY dos
DECLARE FUNCTION LONGINT FWrite( BPTR fh, APTR theBlock, LONGINT blocklen, \
                                 LONGINT number ) LIBRARY dos
DECLARE FUNCTION STRPTR FGets( BPTR fh, STRPTR buf, LONGINT buflen ) LIBRARY dos
DECLARE FUNCTION LONGINT FPuts( BPTR fh, STRPTR str ) LIBRARY dos
DECLARE FUNCTION VFWritef( BPTR fh, STRPTR format, ADDRESS argarray ) LIBRARY dos
DECLARE FUNCTION LONGINT VFPrintf( BPTR fh, STRPTR format, APTR argarray ) LIBRARY dos
DECLARE FUNCTION LONGINT Flush( BPTR fh ) LIBRARY dos
DECLARE FUNCTION LONGINT SetVBuf( BPTR fh, STRPTR buff, LONGINT _TYPE, LONGINT _SIZE ) LIBRARY dos
/*  DOS Object Management */
DECLARE FUNCTION BPTR DupLockFromFH( BPTR fh ) LIBRARY dos
DECLARE FUNCTION BPTR OpenFromLock( BPTR lock ) LIBRARY dos
DECLARE FUNCTION BPTR ParentOfFH( BPTR fh ) LIBRARY dos
DECLARE FUNCTION BOOL ExamineFH( BPTR fh, STRUCTPTR fib ) LIBRARY dos
DECLARE FUNCTION LONGINT SetFileDate( STRPTR _NAME, STRUCTPTR date ) LIBRARY dos
DECLARE FUNCTION LONGINT NameFromLock( BPTR lock, STRPTR buffer, LONGINT _LEN ) LIBRARY dos
DECLARE FUNCTION LONGINT NameFromFH( BPTR fh, STRPTR buffer, LONGINT _LEN ) LIBRARY dos
DECLARE FUNCTION SHORTINT SplitName( STRPTR _NAME, LONGINT seperator, STRPTR buf, LONGINT oldpos, \
                                     LONGINT _SIZE ) LIBRARY dos
DECLARE FUNCTION LONGINT SameLock( BPTR lock1, BPTR lock2 ) LIBRARY dos
DECLARE FUNCTION LONGINT SetMode( BPTR fh, LONGINT mode ) LIBRARY dos
DECLARE FUNCTION LONGINT ExAll( BPTR lock, STRUCTPTR buffer, LONGINT _SIZE, LONGINT _DATA, \
                                STRUCTPTR control ) LIBRARY dos
DECLARE FUNCTION LONGINT ReadLink( STRUCTPTR port, BPTR lock, STRPTR path, STRPTR buffer, \
                                   LONGINT _SIZE ) LIBRARY dos
DECLARE FUNCTION LONGINT MakeLink( STRPTR _NAME, LONGINT dest, LONGINT soft ) LIBRARY dos
DECLARE FUNCTION LONGINT ChangeMode( LONGINT _TYPE, BPTR fh, LONGINT newmode ) LIBRARY dos
DECLARE FUNCTION LONGINT SetFileSize( BPTR fh, LONGINT _POS, LONGINT mode ) LIBRARY dos
/*  ERROR Handling */
DECLARE FUNCTION LONGINT SetIoErr( LONGINT result ) LIBRARY dos
DECLARE FUNCTION BOOL Fault( LONGINT code, STRPTR header, STRPTR buffer, LONGINT _LEN ) LIBRARY dos
DECLARE FUNCTION BOOL PrintFault( LONGINT code, STRPTR header ) LIBRARY dos
DECLARE FUNCTION LONGINT ErrorReport( LONGINT code, LONGINT _TYPE,LONGINT arg1, \
                                      STRUCTPTR device ) LIBRARY dos
/*  Process Management */
DECLARE FUNCTION STRUCTPTR Cli() LIBRARY dos
DECLARE FUNCTION STRUCTPTR CreateNewProc( STRUCTPTR tags ) LIBRARY dos
DECLARE FUNCTION LONGINT RunCommand( BPTR seg, LONGINT stack, STRPTR paramptr, LONGINT paramlen ) LIBRARY dos
DECLARE FUNCTION STRUCTPTR GetConsoleTask() LIBRARY dos
DECLARE FUNCTION STRUCTPTR SetConsoleTask( STRUCTPTR task ) LIBRARY dos
DECLARE FUNCTION STRUCTPTR GetFileSysTask() LIBRARY dos
DECLARE FUNCTION STRUCTPTR SetFileSysTask( STRUCTPTR task ) LIBRARY dos
DECLARE FUNCTION STRPTR GetArgStr() LIBRARY dos
DECLARE FUNCTION BOOL SetArgStr( STRPTR _STRING ) LIBRARY dos
DECLARE FUNCTION STRUCTPTR FindCliProc( LONGINT num ) LIBRARY dos
DECLARE FUNCTION LONGINT MaxCli() LIBRARY dos
DECLARE FUNCTION BOOL SetCurrentDirName( STRPTR _NAME ) LIBRARY dos
DECLARE FUNCTION BOOL GetCurrentDirName( STRPTR buf, LONGINT _LEN ) LIBRARY dos
DECLARE FUNCTION BOOL SetProgramName( STRPTR _NAME ) LIBRARY dos
DECLARE FUNCTION BOOL GetProgramName( STRPTR buf, LONGINT _LEN ) LIBRARY dos
DECLARE FUNCTION BOOL SetPrompt( STRPTR _NAME ) LIBRARY dos
DECLARE FUNCTION BOOL GetPrompt( STRPTR buf, LONGINT _LEN ) LIBRARY dos
DECLARE FUNCTION BPTR SetProgramDir( BPTR lock ) LIBRARY dos
DECLARE FUNCTION BPTR GetProgramDir() LIBRARY dos
/*  Device LIST Management */
DECLARE FUNCTION LONGINT SystemTagList( STRPTR command, STRUCTPTR tags ) LIBRARY dos
DECLARE FUNCTION LONGINT AssignLock( STRPTR _NAME, BPTR lock ) LIBRARY dos
DECLARE FUNCTION BOOL AssignLate( STRPTR _NAME, STRPTR path ) LIBRARY dos
DECLARE FUNCTION BOOL AssignPath( STRPTR _NAME, STRPTR path ) LIBRARY dos
DECLARE FUNCTION BOOL AssignAdd( STRPTR _NAME, BPTR lock ) LIBRARY dos
DECLARE FUNCTION LONGINT RemAssignList( STRPTR _NAME, BPTR lock ) LIBRARY dos
DECLARE FUNCTION STRUCTPTR GetDeviceProc( STRPTR _NAME, STRUCTPTR dp ) LIBRARY dos
DECLARE FUNCTION FreeDeviceProc( STRUCTPTR dp ) LIBRARY dos
DECLARE FUNCTION STRUCTPTR LockDosList( LONGINT flags ) LIBRARY dos
DECLARE FUNCTION UnLockDosList( LONGINT flags ) LIBRARY dos
DECLARE FUNCTION STRUCTPTR AttemptLockDosList( LONGINT flags ) LIBRARY dos
DECLARE FUNCTION BOOL RemDosEntry( STRUCTPTR dlist ) LIBRARY dos
DECLARE FUNCTION LONGINT AddDosEntry( STRUCTPTR dlist ) LIBRARY dos
DECLARE FUNCTION STRUCTPTR FindDosEntry( STRUCTPTR dlist, STRPTR _NAME, \
                                         LONGINT flags ) LIBRARY dos
DECLARE FUNCTION STRUCTPTR NextDosEntry( STRUCTPTR dlist, LONGINT flags ) LIBRARY dos
DECLARE FUNCTION STRUCTPTR MakeDosEntry( STRPTR _NAME, LONGINT _TYPE ) LIBRARY dos
DECLARE FUNCTION FreeDosEntry( STRUCTPTR dlist ) LIBRARY dos
DECLARE FUNCTION BOOL IsFileSystem( STRPTR _NAME ) LIBRARY dos
/*  Handler Interface */
DECLARE FUNCTION BOOL Format( STRPTR filesystem, STRPTR volumename, LONGINT dostype ) LIBRARY dos
DECLARE FUNCTION LONGINT Relabel( STRPTR drive, STRPTR newname ) LIBRARY dos
DECLARE FUNCTION LONGINT Inhibit( STRPTR _NAME, LONGINT onoff ) LIBRARY dos
DECLARE FUNCTION LONGINT AddBuffers( STRPTR _NAME, LONGINT number ) LIBRARY dos
/*  Date, Time Routines */
DECLARE FUNCTION LONGINT CompareDates( STRUCTPTR date1, STRUCTPTR date2 ) LIBRARY dos
DECLARE FUNCTION LONGINT DateToStr( STRUCTPTR datetime ) LIBRARY dos
DECLARE FUNCTION LONGINT StrToDate( STRUCTPTR datetime ) LIBRARY dos
/*  Image Management */
DECLARE FUNCTION BPTR InternalLoadSeg( BPTR fh, BPTR table, ADDRESS funcarray, ADDRESS stack ) LIBRARY dos
DECLARE FUNCTION BOOL InternalUnLoadSeg( BPTR seglist, ADDRESS freefunc ) LIBRARY dos
DECLARE FUNCTION BPTR NewLoadSeg( STRPTR file, STRUCTPTR tags ) LIBRARY dos
DECLARE FUNCTION LONGINT AddSegment( STRPTR _NAME, BPTR seg, LONGINT _SYSTEM ) LIBRARY dos
DECLARE FUNCTION STRUCTPTR FindSegment( STRPTR _NAME, STRUCTPTR seg, LONGINT _SYSTEM ) LIBRARY dos
DECLARE FUNCTION LONGINT RemSegment( STRUCTPTR seg ) LIBRARY dos
/*  Command Support */
DECLARE FUNCTION LONGINT CheckSignal( LONGINT mask ) LIBRARY dos
DECLARE FUNCTION STRUCTPTR ReadArgs( STRPTR arg_template, ADDRESS array, \
                                     STRUCTPTR args ) LIBRARY dos
DECLARE FUNCTION LONGINT FindArg( STRPTR keyword, STRPTR arg_template ) LIBRARY dos
DECLARE FUNCTION LONGINT ReadItem( STRPTR _NAME, LONGINT maxchars, STRUCTPTR cSource ) LIBRARY dos
DECLARE FUNCTION LONGINT StrToLong( STRPTR _STRING, ADDRESS value ) LIBRARY dos
DECLARE FUNCTION LONGINT MatchFirst( STRPTR pat, STRUCTPTR anchor ) LIBRARY dos
DECLARE FUNCTION LONGINT MatchNext( STRUCTPTR anchor ) LIBRARY dos
DECLARE FUNCTION MatchEnd( STRUCTPTR anchor ) LIBRARY dos
DECLARE FUNCTION LONGINT ParsePattern( STRPTR pat, STRPTR buf, LONGINT buflen ) LIBRARY dos
DECLARE FUNCTION BOOL MatchPattern( STRPTR pat, STRPTR str ) LIBRARY dos
DECLARE FUNCTION FreeArgs( STRUCTPTR args ) LIBRARY dos
DECLARE FUNCTION STRPTR FilePart( STRPTR path ) LIBRARY dos
DECLARE FUNCTION STRPTR PathPart( STRPTR path ) LIBRARY dos
DECLARE FUNCTION BOOL AddPart( STRPTR dirname, STRPTR filename, LONGINT _SIZE ) LIBRARY dos
/*  Notification */
DECLARE FUNCTION BOOL StartNotify( STRUCTptrnotify ) LIBRARY dos
DECLARE FUNCTION EndNotify( STRUCTPTR notify ) LIBRARY dos
/*  Environment Variable functions */
DECLARE FUNCTION BOOL SetVar( STRPTR _NAME, STRPTR buffer, LONGINT _SIZE, LONGINT flags ) LIBRARY dos
DECLARE FUNCTION LONGINT GetVar( STRPTR _NAME, STRPTR buffer, LONGINT _SIZE, LONGINT flags ) LIBRARY dos
DECLARE FUNCTION LONGINT DeleteVar( STRPTR _NAME, LONGINT flags ) LIBRARY dos
DECLARE FUNCTION STRUCTPTR FindVar( STRPTR _NAME, LONGINT _TYPE ) LIBRARY dos
DECLARE FUNCTION LONGINT CliInitNewcli( STRUCTPTR dp ) LIBRARY dos
DECLARE FUNCTION LONGINT CliInitRun( STRUCTPTR dp ) LIBRARY dos
DECLARE FUNCTION LONGINT WriteChars( STRPTR buf, LONGINT buflen ) LIBRARY dos
DECLARE FUNCTION LONGINT PutStr( STRPTR str ) LIBRARY dos
DECLARE FUNCTION LONGINT VPrintf( STRPTR format, APTR argarray ) LIBRARY dos
/* these were unimplemented UNTIL dos 36.147 */
DECLARE FUNCTION LONGINT ParsePatternNoCase( STRPTR pat, STRPTR buf, LONGINT buflen ) LIBRARY dos
DECLARE FUNCTION BOOL MatchPatternNoCase( STRPTR pat, STRPTR str ) LIBRARY dos
/* this was added FOR V37 dos, returned 0 before THEN. */
DECLARE FUNCTION BOOL SameDevice( BPTR lock1, BPTR lock2 ) LIBRARY dos

/* NOTE: the following entries did NOT exist before ks 36.303 (2.02) */
/* IF you are going TO use them, OPEN dos.LIBRARY with version 37 */

/* These calls were added FOR V39 dos: */
DECLARE FUNCTION ExAllEnd( BPTR lock, STRUCTptrbuffer, LONGINT _SIZE, LONGINT _DATA, \
                           STRUCTPTR control ) LIBRARY dos
DECLARE FUNCTION BOOL SetOwner( STRPTR _NAME, LONGINT owner_info ) LIBRARY dos

#endif   /* FUNCS_DOS_FUNCS_H */
